--
-- DirtNodesAnimations
--
--
-- @author John Deere 6930
-- @date 04/12/2017
--

DirtNodesAnimations = {};

function DirtNodesAnimations.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(AnimatedVehicle, specializations) and SpecializationUtil.hasSpecialization(Washable, specializations);
end

function DirtNodesAnimations:preLoad(savegame)	
end

function DirtNodesAnimations:load(savegame)	
	self.setDirtAnimation = DirtNodesAnimations.setDirtAnimation;
	
	self.dirtNodesAnimation = getXMLString(self.xmlFile, "vehicle.washable#dirtNodesAnimation");
	self.lastUpdatedDirtAmount = 0.0;
end;

function DirtNodesAnimations:postLoad(savegame)
	if self.dirtNodesAnimation ~= nil then
		local dirtAmount = 0.0;
		if savegame ~= nil and not savegame.resetVehicles then
			dirtAmount = getXMLInt(savegame.xmlFile, savegame.key.."#dirtAmount");
		end;	
		self:setDirtAnimation(dirtAmount);
	end;
end

function DirtNodesAnimations:delete()
end

function DirtNodesAnimations:mouseEvent(posX, posY, isDown, isUp, button)
end

function DirtNodesAnimations:keyEvent(unicode, sym, modifier, isDown)
end

function DirtNodesAnimations:update(dt)
end;

function DirtNodesAnimations:updateTick(dt)
	if self.dirtNodesAnimation ~= nil then
		local dirtAmount = self:getDirtAmount();
		if self.lastUpdatedDirtAmount+0.05 < dirtAmount or self.lastUpdatedDirtAmount-0.05 > dirtAmount then
			self:setDirtAnimation(dirtAmount);
		end;
	end;
end;

function DirtNodesAnimations:draw()
end;

function DirtNodesAnimations:setDirtAnimation(dirtAmount)
	self:setAnimationTime(self.dirtNodesAnimation, dirtAmount);
	AnimatedVehicle.updateAnimations(self, 99999999)
	self.lastUpdatedDirtAmount = dirtAmount;
	
		--local timeA = self:getAnimationTime(self.dirtNodesAnimation)
		--print(self.dirtNodesAnimation..": "..timeA.." -- change "..dirtAmount) 
end;

