UpdateHectareCounterEvent = {};
UpdateHectareCounterEvent_mt = Class(UpdateHectareCounterEvent, Event);

InitEventClass(UpdateHectareCounterEvent, "UpdateHectareCounterEvent");

function UpdateHectareCounterEvent:emptyNew()
    local self = Event:new(UpdateHectareCounterEvent_mt);
    self.className="UpdateHectareCounterEvent";
    return self;
end;

function UpdateHectareCounterEvent:new(vehicle, hectareCounterType, hectareCount)
    local self = UpdateHectareCounterEvent:emptyNew()
    self.vehicle = vehicle;
	self.hectareCounterType = hectareCounterType;
	self.hectareCount = hectareCount;
    return self;
end;

function UpdateHectareCounterEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.hectareCounterType = streamReadInt8(streamId);
	self.hectareCount = streamReadFloat32(streamId);
    self.vehicle = networkGetObject(id);
    self:run(connection);
end;

function UpdateHectareCounterEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteInt8(streamId, self.hectareCounterType);
	streamWriteFloat32(streamId, self.hectareCount);
end;

function UpdateHectareCounterEvent:run(connection)
	self.vehicle:updateHectareCounter(self.hectareCounterType, self.hectareCount, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(UpdateHectareCounterEvent:new(self.vehicle, self.hectareCounterType, self.hectareCount), nil, connection, self.vehicle);
    end;
end;

function UpdateHectareCounterEvent.sendEvent(vehicle, hectareCounterType, hectareCount, noEventSend)
    if hectareCount ~= vehicle.hectareCounters[hectareCounterType].counter then
        if noEventSend == nil or noEventSend == false then
            if g_server ~= nil then
                g_server:broadcastEvent(UpdateHectareCounterEvent:new(vehicle, hectareCounterType, hectareCount), nil, nil, vehicle);
            else
                g_client:getServerConnection():sendEvent(UpdateHectareCounterEvent:new(vehicle, hectareCounterType, hectareCount));
            end;
        end;
    end;
end;

